> For the complete documentation index, see [llms.txt](https://docs.keycloakify.dev/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.keycloakify.dev/keycloakify/v10/customization-strategies/css-level-customization.md).

# CSS Level Customization

Keycloakify enables you to customize the pages without changing the React component by using CSS, SASS LESS Tailwind or a [CSS in JS solution](#user-content-fn-1)[^1].

If you can make it work, CSS Level Customization is preferable over component level customization since it's much easier to maintain.

If you want to use a component library like MUI, ShadeCN/UI or Antlr, this is not the approach that you should favor you should instead checkout [Component Level customization](/keycloakify/v10/customization-strategies/component-level-customization.md).

{% content-ref url="/pages/7UsQLoug27by7bEllN1N" %}
[Basic example](/keycloakify/v10/customization-strategies/css-level-customization/basic-example.md)
{% endcontent-ref %}

[^1]: Example: Emotion or tss-react.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.keycloakify.dev/keycloakify/v10/customization-strategies/css-level-customization.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
